#include <stdlib.h>
#include <stdio.h>
#include <stdarg.h>

extern "C" {
#include "amqbridge.h"
}

#include "amqproducer.h"

extern "C" void amqx(const char *format, ...)
{
	va_list ap;
	
	va_start(ap, format);
	FILE *fh = fopen("/tmp/gaga", "a");
	if (fh) {
		vfprintf(fh,format, ap);
		fclose(fh);
	}
	
} // amqx()

extern "C" void amq_msg_rem(void *p, const char *path)
{
	AmqBridge *ab = (AmqBridge *)p;
	
	std::string s("<?xml version=\"1.0\" encoding=\"UTF-8\"?><fsrm><path><![CDATA[");
	s += path;
	s += "]]></path></fsrm>";
	
	ab->postEvent(s);
	
} // amq_msg_removal()


extern "C" void amq_msg_new(void *p, const char *path)
{
	AmqBridge *ab = (AmqBridge *)p;
	
	std::string s("<?xml version=\"1.0\" encoding=\"UTF-8\"?><fsnew><path><![CDATA[");
	s += path;
	s += "]]></path></fsnew>";
	
	ab->postEvent(s);
	
} // amq_msg_new()

extern "C" void * amqinit(const char * brokerUri,
													const char * destUri,
													int useTopic,
													int clientAck) {
	
	AmqBridge *bridge = new AmqBridge( (std::string) brokerUri,
																		 (std::string) destUri,
																		 useTopic ? true : false,
																		 clientAck ? true : false
																		 );
	
	
	try {
		bridge->connect();
	} catch (CMSException& e) {
		//e.printStackTrace();
		fprintf(
            stderr,
            "ActiveMQ-cpp connection failed: %s\n",
						e.getMessage().c_str()
						);
		
		return NULL;
	}
	
	return bridge;
	
} // amqinit()

extern "C" void * amqexit(void * p)
{
	AmqBridge * bridge = (AmqBridge *)p;
	delete bridge;
} // amqexit()
